        ;
	; LOCS 
	;
	; by Oscar Toledo G.
	; (c) Copyright 1988 Oscar Toledo G.
	;
	; Creation date: Sep/09/1988. I was age 9.
	;

	;
	; Layer to adapt it to MSX computers.
	;
WRTVDP: EQU $0047       ; Set VDP address HL.
WRTVRM: EQU $004D       ; Write byte A to VRAM address HL.
FILVRM: EQU $0056       ; Fill VRAM address HL with A repeated BC times.
SETWRT: EQU $0053       ; Set write address HL for VDP.
CHGET:  EQU $009F       ; Read character from keyboard into A.

VDP:    EQU $98         ; Base VDP port.

        ; MSX Cartridge header

        ORG $4000
        DB "AB"
        DW START
        DW 0
        DW 0
        DW 0
        DW 0

	;
	; Set a VDP address to write.
	;
L0100:  JP SETWRT

	;
	; Copy immediate data to VRAM.
	;
L0169:  EX (SP),HL

.1:     LD A,(HL)
        OR A
        JR Z,.2
        OUT (VDP),a
        INC HL
        JR .1

.2:     EX (SP),HL
        RET

        ;
        ; Clear the screen.
        ; Set screen buffer to VRAM $3c00.
        ;
L04CC:
        LD BC,$0F02     ; VDP register 2 = $3c00.
        CALL WRTVDP
        LD HL,$3C00     ; Clear the screen.
        LD BC,$0300     ; 32x24 grid.
        LD A,$20        ; Space character.
        JP FILVRM       ; Fill VRAM.

	;
	; Read the keyboard.
	;
L04F5:
        CALL CHGET      ; Read keyboard.
        CP $61          ; Is it lowercase?
        RET C
        CP $7B
        RET NC          ; No, return.
        SUB $20         ; Yes, make it uppercase.
        RET

	;
	; Read a hexadecimal number in HL.
	;
READ_WORD:
        CALL READ_BYTE	; Read a byte.
READ_BYTE:
        CALL READ_HEX	; Read a hexadecimal digit.
READ_HEX:
        CALL L04F5	; Read the keyboard.
        PUSH HL
        LD HL,(L87F0)	; Get cursor address.
        CALL WRTVRM	; Display key on the screen.
        INC HL
        LD (L87F0),HL	; Update cursor address.
        POP HL
        SUB $30		; Convert ASCII 0-9 to 0-9.
        CP $0A
        JR C,.1
        SUB $07		; Convert ASCII A-F to 10-15.
.1:     ADD HL,HL	; Shift HL to the left 4 bits.
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        OR L		; Add hexadecimal digit.
        LD L,A
        RET

START:
	LD SP,L87F0
	CALL L8114
	CALL L0100
	CALL L0169
	DB "LOCS OTEK",0
    IF 0
	LD HL,$3C41
	CALL L0100
	CALL L0169
	DB "32 BYTES",0
    ELSE
	DB 0,0,0
	DB 0,0,0
	DB 0,0,0
	DB 0,0,0,0
	DB 0,0,0,0
	DB 0
    ENDIF
L8028:	CALL L81C1	; Point to command area.
	CALL L807F	; Draw the turtle and point to VRAM.
	CALL L0169	; Show it is ready.
	DB "GRAFICO",0
	LD HL,$3EE1	; Point to next row.
	CALL L8063
	LD A,$3E	; Draw the > sign.
        OUT (VDP),A
	LD (L86F2),HL	; Current position in screen.
	LD DE,L8700	; Pointer to start of the buffer.
L8049:	CALL L04F5	; Read the keyboard.
	LD (DE),A	; Save into the buffer.
	INC DE		; Go to the next byte.
	CP $0D		; Is it Enter?
	JR Z,L8068	; Yes, jump.
	LD HL,(L86F2)
	PUSH AF
	CALL L0100	
	POP AF
        OUT (VDP),A	; Show it on the screen.
	INC HL
	LD (L86F2),HL
	JP L8049	; Repeat the loop.

L8063:	CALL L0100
	INC HL
	RET

L8068:	LD A,(L8700)	; Read first typed letter.
	CP $42		; Is it B?
	JR NZ,L808F	; No, jump.
	CALL L04CC	; Clear the screen.
	JP L8028	; Jump back to loop.

L8075:	LD HL,$3D50	; Setup "turtle" in the center of the screen.
	LD (L86F0),HL
	CALL L04CC	; Clear the screen.
	RET

	;
	; Draw the "turtle"
	;
L807F:	PUSH HL
	LD HL,(L86F0)	; Get current position.
	CALL L0100	; Point to VRAM.
	LD A,$2A	; Asterisk.
        OUT (VDP),A	; Write in VRAM.
	POP HL
	CALL L0100	; Point to VRAM.
	RET

L808F:	CP $54		; Is it T? (TORTUGA)
	JR NZ,L80BF	; No, jump.
	LD HL,(L86F0)	; Get the current turtle position.
	CALL L0100
	LD A,$20	; Erase it.
        OUT (VDP),A
	LD HL,$3D50	; Recenter it.
	LD (L86F0),HL
	CALL L0100
	LD A,$2A	; Redraw it.
	OUT (VDP),A
	CALL L80B0	; Erase the command area.
	JP L8028	; Jump back to the loop.

	;
	; Erase the command area.
	;
L80B0:	LD HL,$3EC1	; Point to the bottom 2 rows.
L80B3:	CALL L0100
	LD B,$40	; 32 columns x 2 rows = 64 bytes.
L80B8:	LD A,$20	; Spaces.
        OUT (VDP),A
	DJNZ L80B8
	RET

L80BF:	CP $53		; Is it S? (SM)		
	JR NZ,L80E6
	LD A,(L8700+3)	; Read length.
	SUB $30
	LD B,A
L80C9:	LD HL,(L86F0)
	CALL L0100
	LD A,$23	; Draw block.
        OUT (VDP),A
	LD DE,$0020	; One row up.
	SBC HL,DE
	LD (L86F0),HL
	DJNZ L80C9	; Repeat.
	CALL L80B0	; Erase command area.
	CALL L807F	; Redraw turtle.
	JP L8028	; Jump to main loop.

L80E6:	CP $44		; Is it D? (DM)
        JR NZ,L811B
	LD A,(L8700+3)	; Read length.
	SUB $30
	LD B,A
L80F0:	LD HL,(L86F0)
	CALL L0100
	LD A,$23	; Draw block.
        OUT (VDP),A
	LD DE,$0001	; One column right.
	ADD HL,DE
	NOP
	LD (L86F0),HL
	DJNZ L80F0	; Repeat.
	CALL L80B0	; Erase command area.
	CALL L807F	; Redraw turtle.
	JP L8028	; Jump to main loop.

	DB $FF,$FF,$FF
	DB $FF,$FF,$FF,$FF

L8114:	CALL L8075
	LD HL,$3C01	; Top-left corner of the screen.
	RET

L811B:	CP $41		; Is it A? (AM)
	JR NZ,L8142	; No, jump.
	LD A,(L8700+3)	; Read length.
	SUB $30
	LD B,A
L8125:	LD HL,(L86F0)
	CALL L0100
        LD A,$23	; Draw block.
        OUT (VDP),A
	LD DE,$0020	; One row down.
	ADD HL,DE
	NOP
	LD (L86F0),HL
	DJNZ L8125
	CALL L80B0	; Erase command area.
	CALL L807F	; Redraw turtle.
	JP L8028	; Jump to main loop.

L8142:	CP $49		; Is it I? (IM)
	JR NZ,L8169	; No, jump.
	LD A,(L8700+3)	; Read length.
	SUB $30
	LD B,A
L814C:	LD HL,(L86F0)
	CALL L0100
	LD A,$23	; Draw block.
        OUT (VDP),A
	LD DE,$0001	; One column to left.
	SBC HL,DE
	LD (L86F0),HL
	DJNZ L814C
	CALL L80B0	; Erase command area.
	CALL L807F	; Redraw turtle.
	JP L8028	; Jump to main loop.

L8169:	CP $50		; Is it P? (PT)
	JR NZ,L8194-1	; No, jump.
	LD HL,$3EE5
	LD (L87F0),HL
        CALL READ_WORD  ; Modified from RST $10
	LD D,H
	LD E,L
	LD HL,(L86F0)	; Current turtle position.
	CALL L0100
	LD A,$20	; Erase turtle.
        OUT (VDP),A
	LD HL,$3C00	; Put desired value into VRAM space.
	ADD HL,DE
	LD (L86F0),HL	; Save as new turtle position.
	CALL L0100
	LD A,$2A	; Draw turtle.
        OUT (VDP),A
	CALL L80B0	; Erase command area.
	JP L8028	; Jump to main loop.

	;
	; Unrecognized command.
	;
L8194:	LD HL,$3C01
	CALL L0100
	CALL L0169
	DB "* ERROR *",0
	LD B,$05
L81A9:	PUSH BC
	LD BC,$0000	; Big delay.
L81AD:	DEC BC
	LD A,B
	OR C
	JR NZ,L81AD
	POP BC
	DJNZ L81A9
	LD HL,$3C00
	CALL L80B3	; Erase error message.
	CALL L80B0	; Erase command area.
	JP L8028	; Jump to main loop.

L81C1:  LD HL,$0118	; Redefine the # character
	CALL L0100	; as a solid block.
	LD B,$08
L81C9:	LD A,$FF
        OUT (VDP),A
	DJNZ L81C9
L81CF:  LD HL,$0918
	CALL L0100
	LD B,$08
L81D7:	LD A,$FF
        OUT (VDP),A
	DJNZ L81D7
        LD HL,$1118
	CALL L0100
	LD B,$08
L81E5:	LD A,$FF
        OUT (VDP),A
	DJNZ L81E5
	LD HL,$3EC1	; Point to command area.
	RET
	
L86F0:  EQU $E6F0
L86F2:  EQU $E6F2
L8700:  EQU $E700
L87F0:  EQU $E7F0
